【力扣hot100题】(089)最长有效括号

这题目真是越做越难了。

但其实只是思路很难想到,一旦会了方法就很好做。

但问题就在方法太难想了......

思路还是只要遍历一遍数组,维护动态规划数组记录截止至目前位置选取该元素的情况下有效括号的最大值。

光是知道这个还不够,看了答案才知道每次可以取两个元素。

具体来说分三种情况:

  • 当前元素为'(',则最后取该元素时一定没有有效括号,所以元素取为0.
  • 当前元素为')',并且前面有元素且上一个元素为'(',这种情况就等于上上个元素数组维护的值加上2。
  • 当前元素为')',并且前面有元素且上一个元素为')',这种情况就要追溯到前面有效括号再之前的元素,如果前面有有效括号并且前面的有效括号前面是'(',这时当前元素前一个元素维护的值恰好记录的那个有效括号的长度,通过减去这个有效长度再减1(原本查看上一个元素也要减1,所以一共减2)就可以得到前面有没有相匹配的'(',于是就可以得到当前维护的数=前面有效括号的长度+2(若当前右括号与前面左括号相匹配)

状态转移方程如上。

cpp 复制代码
class Solution {
public:
    int longestValidParentheses(string s) {
        if(s.size()==0) return 0;
        vector<int> array(s.size()+1,0);
        int result=0;
        for(int i=2;i<=s.size();i++){
            if(s[i-1]=='(') array[i]=0;
            else if(s[i-2]=='('&&s[i-1]==')') array[i]=array[i-2]+2;
            else if(s[i-2]==')'&&s[i-1]==')'&&i>=array[i-1]+2&&s[i-array[i-1]-2]=='(') array[i]=array[i-array[i-1]-2]+array[i-1]+2;
            result=max(result,array[i]);
        }
        return result;
    }
};
相关推荐
mmmmath_39 小时前
LeetCode.199.二叉树的右视图
数据结构·leetcode
专注仿真9 小时前
引擎扩展性与集成设计深度剖析:从 14 个扩展点到 DIS→HLA 演进之路
开发语言·算法·仿真引擎·推演引擎
码爸9 小时前
支持向量机介绍与示例
算法·机器学习·支持向量机
怕浪猫9 小时前
2028编程圈很火的10个Skills
算法·面试·github
Nil20814 小时前
leetcode 198打家劫舍
算法·leetcode·职场和发展
Shaoshing14 小时前
前缀和与差分
java·数据结构·算法·前缀和·差分
mmmmath_314 小时前
LeetCode.429.N叉树的层序遍历
数据结构·leetcode
loulanyue_15 小时前
构建房产认知决策智能:Harness底座与AI自进化的技术实践——读贝壳首席算法科学家尹俊希2026云栖专场演讲
人工智能·算法
碧海银沙音频科技研究院15 小时前
基于炬芯ATS录音卡BLE控制协议
人工智能·嵌入式硬件·算法·语音识别
suhan15 小时前
【数据结构】三、栈和队列:6.链队列、双端队列、队列的应用(树的层次遍历、广度优先BFS、先来先服务FCFS)
数据结构·后端·算法